*
*	multi music status display MMDSP v0.29 Rel.15
*
*			program parts of 'MLD'
*

		.include	mldfunc.mac
		.include	doscall.mac
		.include	mmdsp.equ


* Global Symbol ------------------------------- *

		.xref	EXEC_EXTERNAL
		.xref	mpf_setup


* Text Section -------------------------------- *

		.cpu	68000

		.offset	DRV_WORK
MLD_SYSBUF:	.DS.L	1
MLD_TRKBUF::	.DS.L	32
		.text


*
* MLD JUMP TABLE
*
MLD_ENTRY::
		.DC.W	MLD_CHECK-MLD_ENTRY
		.DC.W	MLD_NAME-MLD_ENTRY
		.DC.W	MLD_INIT-MLD_ENTRY
		.DC.W	MLD_SYSSTAT-MLD_ENTRY
		.DC.W	MLD_TRKSTAT-MLD_ENTRY
		.DC.W	MLD_GETMASK-MLD_ENTRY
		.DC.W	MLD_SETMASK-MLD_ENTRY
		.DC.W	MLD_FILEEXT-MLD_ENTRY
		.DC.W	MLD_FLOADP-MLD_ENTRY
		.DC.W	MLD_PLAY-MLD_ENTRY
		.DC.W	MLD_PAUSE-MLD_ENTRY
		.DC.W	MLD_CONT-MLD_ENTRY
		.DC.W	MLD_STOP-MLD_ENTRY
		.DC.W	MLD_FADEOUT-MLD_ENTRY
		.DC.W	MLD_SKIP-MLD_ENTRY
		.DC.W	MLD_SLOW-MLD_ENTRY

*
* KEEP CHECK
*
MLD_CHECK:
		MOVE.L	A0,-(SP)
		MOVE.L	$90.W,A0
		LEA.L	-16(A0),A0
		CMPI.L	#'  Ri',(A0)+
		BNE	MLD_CHECK2
		CMPI.L	#"e'MI",(A0)+
		BNE	MLD_CHECK2
		CMPI.L	#'DI  ',(A0)+
		BNE	MLD_CHECK2
		MOVE.L	(A0),D0
		CMPI.L	#$02240000,D0
		BCC	MLD_CHECK3
MLD_CHECK2:
		MOVEQ.L	#$FF,D0
MLD_CHECK3:
		MOVE.L	(SP)+,A0
		RTS

*
* GET DRIVER NAME
*
MLD_NAME:
		PEA.L	MLD_NAMESTR(PC)			* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

MLD_NAMESTR:
		.DC.B	'MLD',0
		.EVEN

*
* INITIALIZE
*
MLD_INIT:
		MOVEM.L	D0-D3/A0,-(SP)
		MOVEQ.L	#0,D1
		MLD	_WORK
		MOVE.L	D0,MLD_SYSBUF(A6)
		LEA.L	MLD_TRKBUF(A6),A0
		MOVEQ.L	#1,D3
		MOVEQ.L	#32-1,D2
MLD_INIT2:
		MOVE.W	D3,D1
		MLD	_WORK
		MOVE.L	D0,(A0)+
		ADDQ.W	#1,D3
		DBRA.W	D2,MLD_INIT2

		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#1,D0
MLD_INIT3:
		MOVE.B	D0,T_TRACKNO(A0)
		LEA.L	TRST(A0),A0
		ADDQ.W	#1,D0
		CMPI.W	#32,D0
		BLS	MLD_INIT3

		CLR.L	TRACK_ENABLE(A6)
		MOVE.W	#249,CYCLETIM(A6)
		MOVE.W	#77,TITLELEN(A6)
		CLR.B	SORCERIAN_FLAG(A6)
		MOVEM.L	(SP)+,D0-D3/A0
		RTS

*
* GET SYSTEM STATUS
*
MLD_SYSSTAT:
		MOVEM.L	D0/A0,-(SP)
		MOVEA.L	MLD_SYSBUF(A6),A0
		MOVE.L	TITLE(A0),SYS_TITLE(A6)
		MOVE.W	LOOPCOUNT(A0),SYS_LOOP(A6)
		MOVEQ.L	#0,D0
		MOVE.B	TEMPO(A0),D0
		MOVE.W	D0,SYS_TEMPO(A6)
		MLD	_PAUSE
		TST.B	D0
		BNE	MLD_SYSSTAT2
		TST.L	PLAYFLG(A0)
		BEQ	MLD_SYSSTAT2
		MOVEQ.L	#$FF,D0
		BRA	MLD_SYSSTAT3
MLD_SYSSTAT2:
		MOVEQ.L	#0,D0
MLD_SYSSTAT3:
		MOVE.W	D0,PLAY_FLAG(A6)
		OR.B	PAUSE(A0),D0
		SEQ.B	D0
		EXT.W	D0
		MOVE.W	D0,PLAYEND_FLAG(A6)
		MOVEM.L	(SP)+,D0/A0
		RTS

*
* GET TRACK STATUS
*
MLD_TRKSTAT:
		MOVEM.L	D0-D7/A0-A2,-(SP)
		MOVEA.L	MLD_SYSBUF(A6),A0
		MOVE.L	MASKFLG(A0),D3
		NOT.L	D3
		AND.L	PLAYFLG(A0),D3
		MOVE.L	TRACK_ENABLE(A6),D0
		MOVE.L	D3,TRACK_ENABLE(A6)
		EOR.L	D3,D0
		MOVE.L	D0,TRACK_CHANGE(A6)

		LEA.L	MLD_TRKBUF(A6),A0
		LEA.L	TRACK_STATUS(A6),A2
		MOVEQ.L	#0,D2
		MOVEQ.L	#32-1,D7
MLD_TRKSTAT2:
		MOVE.L	(A0)+,A1
		BSR	GET_TRACK
		LEA.L	TRST(A2),A2
		ADDQ.W	#1,D2
		DBRA.W	D7,MLD_TRKSTAT2
		MOVEM.L	(SP)+,D0-D7/A0-A2
		RTS

*	d2.w <- track no
*	d3.l <- track enable
*	d5.b    STCHANGE work
*	a1.l <- MLD   track buffer address
*	a2.l <- MMDSP TRACK_STATUS address

GET_TRACK:
		MOVEQ.L	#0,D5
		MOVE.L	D5,T_STCHANGE(A2)

		MOVE.B	trkmdl(A1),D0
		BNE	GET_TRACK2
		MOVEQ.L	#3,D0
GET_TRACK2:
		CMP.B	T_INSTRUMENT(A2),D0
		BEQ	GET_TRACK4
		MOVE.B	D0,T_INSTRUMENT(A2)
		BSET.L	#0,D5
		MOVEQ.L	#$00,D1
		CMPI.B	#2,D0
		BNE	GET_TRACK3
		MOVEQ.L	#$0F,D1
GET_TRACK3:
		MOVE.W	D1,T_KEYOFFSET(A2)
GET_TRACK4:
		CMPI.B	#3,D0
		BNE	GET_TRACK5
		BSR	GETTRK_MIDI
		BRA	GET_TRACK6
GET_TRACK5:
		BSR	GETTRK_FM
GET_TRACK6:
		MOVE.B	D5,T_STCHANGE(A2)
		RTS

* GET TRACK STATUS (OPM)
GETTRK_FM:
		MOVE.W	kf_total(A1),D0		* FM BEND
		ADD.W	detune(A1),D0
		ASR.W	#2,D0
		CMP.W	T_BEND(A2),D0
		BEQ	GETTRK_FM2
		MOVE.W	D0,T_BEND(A2)
		BSET.L	#1,D5
GETTRK_FM2:
		MOVEQ.L	#-1,D0			* FM PAN
		MOVE.B	pan(A1),D0
		ANDI.B	#3,D0
		CMP.W	T_PAN(A2),D0
		BEQ	GETTRK_FM3
		MOVE.W	D0,T_PAN(A2)
		BSET.L	#2,D5
GETTRK_FM3:
		MOVEQ.L	#0,D0			* FM PROGRAM
		MOVE.B	vcenum(A1),D0
		CMP.W	T_PROGRAM(A2),D0
		BEQ	GETTRK_FM4
		MOVE.W	D0,T_PROGRAM(A2)
		BSET.L	#3,D5
GETTRK_FM4:
		BTST.L	D2,D3			* FM KEYON
		BEQ	GETTRK_FM41
		TST.B	keyon_work(A1)
		BEQ	GETTRK_FM41
		CLR.B	keyon_work(A1)
		MOVE.B	#$01,T_KEYONCHANGE(A2)
		MOVE.B	#$FE,T_KEYONSTAT(A2)
		BRA	GETTRK_FM5
GETTRK_FM41:
		BTST.B	#0,T_KEYONSTAT(A2)	* FM KEYOFF
		BNE	GETTRK_FM5
		TST.B	koflg(A1)
		BNE	GETTRK_FM5
		MOVE.B	#$01,T_KEYONCHANGE(A2)
		ST.B	T_KEYONSTAT(A2)
GETTRK_FM5:
		MOVE.B	ntbuf(A1),D0		* FM KEYCODE
		CMP.B	T_KEYCODE(A2),D0
		BEQ	GETTRK_FM6
		MOVE.B	#$01,T_KEYCHANGE(A2)
		MOVE.B	D0,T_KEYCODE(A2)
GETTRK_FM6:
		MOVE.W	opmvol(A1),D0		* FM VELOCITY
		CMPI.B	#2,T_INSTRUMENT(A2)
		BNE	GETTRK_FM61
		MOVE.B	pcmvol(A1),D0
GETTRK_FM61:
		NOT.W	D0
		ANDI.W	#$7F,D0
		CMP.B	T_VELOCITY(A2),D0
		BEQ	GETTRK_FM7
		MOVE.B	#$01,T_VELCHANGE(A2)
		MOVE.B	D0,T_VELOCITY(A2)
GETTRK_FM7:
		RTS

* GET TRACK STATUS (MIDI)
GETTRK_MIDI:
		MOVE.W	bend(A1),D0		* MIDI BEND
		SUBI.W	#8192,D0
		CMP.W	T_BEND(A2),D0
		BEQ	GETTRK_MIDI2
		MOVE.W	D0,T_BEND(A2)
		BSET.L	#1,D5

GETTRK_MIDI2:
		MOVEQ.L	#127,D0			* MIDI PAN
		AND.B	pan(A1),D0
		CMP.W	T_PAN(A2),D0
		BEQ	GETTRK_MIDI3
		MOVE.W	D0,T_PAN(A2)
		BSET.L	#2,D5

GETTRK_MIDI3:
		MOVEQ.L	#0,D0			* MIDI PROGRAM
		MOVE.B	vcenum(A1),D0
		CMP.W	T_PROGRAM(A2),D0
		BEQ	GETTRK_MIDI4
		MOVE.W	D0,T_PROGRAM(A2)
		BSET.L	#3,D5

GETTRK_MIDI4:
		CLR.B	T_KEYONCHANGE(A2)
		ST.B	T_KEYCHANGE(A2)
		CLR.L	T_KEYCODE+0(A2)		* KEYCODE CLEAR
		CLR.L	T_KEYCODE+4(A2)
		MOVEQ.L	#$00,D6
		MOVE.W	ntval(A1),D6
		CMPI.W	#1,D6
		BLS	GETTRK_MIDI5		* ałȂꍇ͒ʏ폈

		BTST.L	D2,D3
		BEQ	GETTRK_MIDI42
		TST.B	keyon_work(A1)
		BEQ	GETTRK_MIDI42
		CLR.B	keyon_work(A1)

* POLYPHONIC KEYON
GETTRK_MIDI41:
		MOVE.B	BITCNV(PC,D6.W),D0
		MOVE.B	D0,T_KEYONCHANGE(A2)
		NOT.B	D0
		MOVE.B	D0,T_KEYONSTAT(A2)
		BRA	GETTRK_MIDI43

* POLYPHONIC KEYOFF
GETTRK_MIDI42:
		BTST.B	#0,T_KEYONSTAT(A2)
		BNE	GETTRK_MIDI43
		TST.B	koflg(A1)
		BNE	GETTRK_MIDI43
		MOVE.B	BITCNV(PC,D6.W),D0
		MOVE.B	D0,T_KEYONCHANGE(A2)
		MOVE.B	D0,T_KEYONSTAT(A2)

* POLYPHONIC KEYCODE
GETTRK_MIDI43:
		MOVE.B	BITCNV(PC,D6.W),D0
		MOVE.B	D0,T_KEYCHANGE(A2)
		SUBQ.W	#1,D6			* FOR DBRA
		MOVEQ.L	#$00,D4
GETTRK_MIDI44:
		MOVE.B	ntbuf(A1,D4.W),D0
*		CMP.B	T_KEYCODE(A2,D4.W),D0
*		BEQ	GETTRK_MIDI45
		MOVE.B	D0,T_KEYCODE(A2,D4.W)
GETTRK_MIDI45:
		ADDQ.W	#1,D4
		DBRA.W	D6,GETTRK_MIDI44
		BRA	GETTRK_MIDI6

* POLYPHONIC CONV.BITMAP
BITCNV:
*			  0,  1,  2,  3,  4,  5,  6,  7,  8
		.DC.B	$00,$01,$03,$07,$0F,$1F,$3F,$7F,$FF
		.EVEN

* NO POLYPHONIC KEYON
GETTRK_MIDI5:
		BTST.L	D2,D3
		BEQ	GETTRK_MIDI51
		TST.B	keyon_work(A1)
		BEQ	GETTRK_MIDI51
		CLR.B	keyon_work(A1)
*		MOVE.B	#$01,T_KEYONCHANGE(A2)	* ωiʂb0jP
		ST.B	T_KEYONCHANGE(A2)
		MOVE.B	#$FE,T_KEYONSTAT(A2)	* iʂb0jO
		BRA	GETTRK_MIDI52

* NO POLYPHONIC KEYOFF
GETTRK_MIDI51:
		BTST.B	#0,T_KEYONSTAT(A2)	* KEYOFF
		BNE	GETTRK_MIDI52
		TST.B	koflg(A1)
		BNE	GETTRK_MIDI52
*		MOVE.B	#$01,T_KEYONCHANGE(A2)
		ST.B	T_KEYONCHANGE(A2)
		ST.B	T_KEYONSTAT(A2)
* NO POLYPHONIC KEYCODE
GETTRK_MIDI52:
		MOVE.B	ntbuf(A1),D0
*		CMP.B	T_KEYCODE(A2),D0
*		BEQ	GETTRK_MIDI6
*		MOVE.B	#$01,T_KEYCHANGE(A2)
		ST.B	T_KEYCHANGE(A2)
		MOVE.B	D0,T_KEYCODE(A2)

GETTRK_MIDI6:
		CLR.B	T_VELCHANGE(A2)
		MOVE.W	vvol(A1),D0
		SUBI.B	#127,D0
		NEG.B	D0
		CMP.B	T_VELOCITY(A2),D0
		BEQ	GETTRK_MIDI7
		MOVE.B	#1,T_VELCHANGE(A2)
		MOVE.B	D0,T_VELOCITY(A2)
GETTRK_MIDI7:
		RTS


*
* GET TRACK MASK
*
MLD_GETMASK:
		MOVE.L	A0,-(SP)
		MOVEA.L	MLD_SYSBUF(A6),A0
		MOVE.L	MASKFLG(A0),D0
		NOT.L	D0
		MOVE.L	(SP)+,A0
		RTS

*
* SET TRACK MASK
*
MLD_SETMASK:
		MOVEM.L	D1-D2,-(SP)
		MOVE.L	D1,D2
		BEQ	MLD_SETMASK2
		NOT.L	D1
		BEQ	MLD_SETMASK3
		MLD	_MSK_SET
		MOVE.L	D2,D1
		MLD	_MSK_RESET
		BRA	MLD_SETMASK4
MLD_SETMASK2:
		MLD	_MSK_SET
		BRA	MLD_SETMASK4
MLD_SETMASK3:
		MLD	_MSK_RESET
MLD_SETMASK4:
		MOVEM.L	(SP)+,D1-D2
		RTS

MLD_FILEEXT:
		PEA.L	FILEEXT_DAT(PC)			* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

FILEEXT_DAT:
		.DC.B	_MDZ,'MDZ'
		.DC.B	_MDX,'MDX'
		.DC.B	_MDR,'MDR'
		.DC.B	_MDI,'MDI'
		.DC.B	_MDN,'MDN'
		.DC.B	_KMD,'KMD'
		.DC.B	_ZMD,'ZMD'
		.DC.B	_RCP,'RCP'
		.DC.B	_MDF,'MDF'
		.DC.B	_ZDF,'ZDF'
		.DC.B	_MPF,'MPF'
		.DC.B	0
		.EVEN

*
* FLOADP
*
MLD_FLOADP:
		cmpi.b	#_MPF,d0
		beq	MLD_MPF

		move.l	d0,d1
		lea.l	MMLP_NAME(pc),a0
		bsr	EXEC_EXTERNAL
		tst.l	d0
		bpl	L0091c4
		moveq.l	#$c,d0

		cmpi.b	#_MDZ,d1
		bne	L0091d0
		lea.l	MLP_NAME(pc),a0
		bsr	EXEC_EXTERNAL
		tst.l	d0
		bpl	L0091c4
		lea.l	NOPROG_STR(pc),a0
		moveq.l	#$c,d0
		bra	L0091d0

L0091c4:
		cmpi.w	#$18,d0
		bls	L0091cc
		moveq.l	#1,d0
L0091cc:
		move.b	ERRCNVTBL(pc,d0.w),d0
L0091d0:
		ext.w	d0
		ext.l	d0
		andi.w	#$7f,d0
		RTS

MMLP_NAME:
		.DC.B	'mmlp',0
MLP_NAME:
		.DC.B	'mlp',0
NOPROG_STR:
		.DC.B	'MMLP / MLP',0

ERRCNVTBL:
		.DC.B	$00,$01,$02,$02,$05,$06,$07,$08
		.DC.B	$0a,$0d,$01,$01,$01,$01,$01,$01
		.DC.B	$01,$06,$0b,$0e,$04,$01,$01,$10
		.DC.B	$11
		.EVEN

MLD_MPF:
		BSR	mpf_setup
		MOVEQ.L	#0,D0
		RTS

*
* PLAY
*
MLD_PLAY:
		MOVE.L	D1,-(SP)
		MOVEQ.L	#0,D1
		MLD	_PLAY
		MOVE.L	(SP)+,D1
		RTS

*
* PAUSE
*
MLD_PAUSE:
		MLD	_STOP
		RTS

*
* CONTINUE
*
MLD_CONT:
		MLD	_CONT
		RTS

*
* STOP
*
MLD_STOP:
		MLD	_END
		RTS

*
* FADEOUT
*
MLD_FADEOUT:
		MOVE.L	D1,-(SP)
		MOVE.W	MMDSP_FADE_SPD(A6),D1
		MLD	_FO_SPD
		MLD	_F_OUT
		MOVE.L	(SP)+,D1
		RTS

*
* SKIP
*
MLD_SKIP:
		TST.W	D0
		BNE	BLD_SKIP2
		CLR.B	$80E.W
		RTS
BLD_SKIP2:
		MOVE.B	#$0A,$80E.W
		RTS

*
* SLOW
*
MLD_SLOW:
		TST.W	D0
		BNE	MLD_SLOW2
		CLR.B	$80E.W
		RTS
MLD_SLOW2:
		MOVE.B	#6,$80E.W
		RTS



		.END
