*
*	multi music status display MMDSP v0.29 Rel.14
*
*			driver parts of 'SORCERIAN (PC88)'
*

		.include	sorcsr.equ
		.include	mmdsp.equ
		.include	doscall.mac


* Global Symbol ------------------------------- *

		.xref	FM_VOL_TBL
		.xref	FNUM_TBL
		.xref	FREQ_TBL
		.xref	KEY_TBL
		.xref	SSG_TL_TBL
		.xref	mxdrv_mpf


* Text Section -------------------------------- *

		.offset	DRV_WORK
SORC88_WORKADR:	.DS.L	1
SORC88_DATAADR:	.DS.L	1
KEYONWK:	.DS.W	8

		.cpu	68000
		.text

*
* SORC88 JOB JUMP TABLE
*
SORC88_ENTRY::
		.DC.W	SORC88_CHECK-SORC88_ENTRY
		.DC.W	SORC88_NAME-SORC88_ENTRY
		.DC.W	SORC88_INIT-SORC88_ENTRY
		.DC.W	SORC88_SYSSTAT-SORC88_ENTRY
		.DC.W	SORC88_TRKSTAT-SORC88_ENTRY
		.DC.W	SORC88_GETMASK-SORC88_ENTRY
		.DC.W	SORC88_SETMASK-SORC88_ENTRY
		.DC.W	SORC88_FILEEXT-SORC88_ENTRY
		.DC.W	SORC88_FLOADP-SORC88_ENTRY
		.DC.W	SORC88_PLAY-SORC88_ENTRY
		.DC.W	SORC88_PAUSE-SORC88_ENTRY
		.DC.W	SORC88_CONT-SORC88_ENTRY
		.DC.W	SORC88_STOP-SORC88_ENTRY
		.DC.W	SORC88_FADEOUT-SORC88_ENTRY
		.DC.W	SORC88_SKIP-SORC88_ENTRY
		.DC.W	SORC88_SLOW-SORC88_ENTRY

*
* KEEP CHECK
*
SORC88_CHECK:
		MOVE.L	A0,-(SP)
		MOVE.L	$84.W,A0
		SUBQ.L	#8,A0
		CMPI.L	#'SORC',(A0)+
		BNE	SORC88_CHECK2
		CMPI.L	#'SR  ',(A0)+
		BEQ	SORC88_CHECK3
SORC88_CHECK2:
		MOVE.L	(SP)+,A0
		MOVEQ.L	#$FF,D0
		RTS

*
* GET FALDRV WORK ADDRESS
*
SORC88_CHECK3:
		SORCSR	_M_GETWORK
		MOVE.L	D0,A0
		MOVE.L	A0,SORC88_WORKADR(A6)
		MOVE.L	M_WORKTOP(A0),SORC88_DATAADR(A6)
		MOVE.L	(SP)+,A0
		MOVEQ.L	#$00,D0
		RTS

*
* GET DRIVER NAME
*
SORC88_NAME:
		PEA.L	SORC88_NAMESTR(PC)		* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

SORC88_NAMESTR:
		.DC.B	'SORCERIAN (PC-88SR)'
SORC88_ENDSTR:
		.DC.B	0
		.EVEN

*
* INITIALIZE
*
SORC88_INIT:
		MOVE.L	A0,-(SP)
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#3-1,D0
SORC88_INIT2:
		MOVE.B	#4,T_INSTRUMENT(A0)		* FM
		MOVE.B	#5,T_INSTRUMENT+TRST*3(A0)	* SSG
		MOVE.W	#12,T_KEYOFFSET(A0)
		MOVE.W	#12,T_KEYOFFSET+TRST*3(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D0,SORC88_INIT2

* TRACK NUMBER
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#1,D0
SORC88_INIT3:
		MOVE.B	D0,T_TRACKNO(A0)
		LEA.L	TRST(A0),A0
		ADDQ.W	#1,D0
		CMPI.W	#7,D0
		BCS	SORC88_INIT3

		CLR.L	TRACK_ENABLE(A6)
		MOVE.W	#292,CYCLETIM(A6)
		MOVE.W	#77,TITLELEN(A6)
		ST.B	SORCERIAN_FLAG(A6)

		LEA.L	KEYONWK(A6),A0		* INITIALIZE KEYON WORK
		MOVEQ.L	#$00,D0
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	(SP)+,A0
		RTS

*
* GET SYSTEM STATUS
*
SORC88_SYSSTAT:
		MOVEM.L	D1-D2/A0,-(SP)
*
		LEA.L	SORC88_ENDSTR(PC),A0
		MOVE.L	A0,SYS_TITLE(A6)
		MOVEQ.L	#$00,D0
		MOVEA.L	SORC88_WORKADR(A6),A0
		CLR.W	SYS_LOOP(A6)

		MOVE.B	M_TEMPO(A0),D0
		MOVE.W	D0,SYS_TEMPO(A6)

		MOVE.B	M_STOP_FLAG(A0),D0	* ttO
		SEQ.B	D1			* D0.B : $00=PLAY, $83=STOP
		EXT.W	D1			*
		MOVE.W	D1,PLAY_FLAG(A6)
		BTST.L	#0,D0
		SNE.B	D1
		EXT.W	D1
		MOVE.W	D1,PLAYEND_FLAG(A6)	* tItO
*
		MOVEM.L	(SP)+,D1-D2/A0
		RTS

*
* GET TRACK STATUS
*
SORC88_TRKSTAT:
		MOVEM.L	D1-D7/A0-A3/A5,-(SP)

* CHECK DATA END 'FF 00 00'
CHECK_DATAEND:
		MOVE.L	SORC88_WORKADR(A6),A5
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D1
		LEA.L	M_CH1(A5),A0
CHECK_DATAEND2:
		TST.B	$1F(A0)
		BMI	CHECK_DATAEND3		* b7:1 = END
		BSET.L	D0,D1
CHECK_DATAEND3:
		LEA.L	$20(A0),A0
		ADDQ.B	#1,D0
		CMPI.B	#6,D0
		BCS	CHECK_DATAEND2
*
		TST.B	D1
		BNE	CHECK_DATAEND4		* ǂ̃gbNĂ

		MOVE.W	#-1,PLAYEND_FLAG(A6)	* PLAY END FLAG SET
		SORCSR	_M_STOP
		BRA	SORC88_TRKSTAT2

* TRACK ALIVE, GET STATUS
CHECK_DATAEND4:
		BSR	SET_KEYBOARD_STATUS
		BSR	SET_TRACK_STATUS
SORC88_TRKSTAT2:
		MOVEM.L	(SP)+,D1-D7/A0-A3/A5
		RTS

*
*	SORC88_KEYBOARD_SET
*@\FSORCSR ̃L[{[hXe[^X𓾂
*óFȂ
*QlFbgrsQaeQviUjɂ
*

SET_KEYBOARD_STATUS:
		LEA.L	CHST_BF(A6),A0
		LEA.L	M_CH1(A5),A2
		LEA.L	TRACK_STATUS(A6),A3
		MOVEQ.L	#6-1,D7
_S88KBS_LOOP:
		MOVEQ.L	#0,D6			* D6.L : FLAG BITMAP

_S88KBS_MP:
		MOVE.B	$1F(A2),D0		* $C : MP
		BTST.L	#3,D0
		SNE	D1
		CMP.B	KBS_MP(A0),D1
		BEQ	_S88KBS_q
		BSET.L	#$C,D6
		MOVE.B	D1,KBS_MP(A0)

_S88KBS_q:
		MOVE.B	$09(A2),D0		* $1 : q
		BEQ	_S88KBS_q2
		SUBQ.B	#1,D0
_S88KBS_q2:
		NEG.B	D0
		CMP.B	KBS_q(A0),D0
		BEQ	_S88KBS_D
		BSET.L	#1,D6
		MOVE.B	D0,KBS_q(A0)

_S88KBS_D:
		MOVE.B	$08(A2),D0		* $2 : D
		EXT.W	D0
		CMP.W	KBS_D(A0),D0
		BEQ	_S88KBS_TONE
		BSET.L	#2,D6
		MOVE.W	D0,KBS_D(A0)

_S88KBS_TONE:
		MOVEQ.L	#$00,D0			* $6 : @
		CMPI.B	#3,$1E(A2)
		BCC	_S88KBS_TONE2
		MOVE.B	5(A2),D0		* el̂
		BRA	_S88KBS_TONE3
_S88KBS_TONE2:
		MOVE.B	5(A2),D0
		LSR.B	#4,D0
		ADDI.B	#100,D0
_S88KBS_TONE3:
		CMP.W	KBS_PROG(A0),D0
		BEQ	_S88KBS_VOL1
		BSET.L	#6,D6
		MOVE.W	D0,KBS_PROG(A0)

_S88KBS_VOL1:
		MOVE.B	$06(A2),D0		* $7 : @v1
		CMPI.B	#3,$1E(A2)
		BCC	_S88KBS_VOL12
		NEG.B	D0			* el̂
		ADDI.B	#127,D0
		ANDI.B	#$7F,D0
_S88KBS_VOL12:
		CMP.B	KBS_TL1(A0),D0
		BEQ	_S88KBS_VOL2
		BSET.L	#7,D6
		MOVE.B	D0,KBS_TL1(A0)
_S88KBS_VOL2:
		MOVE.B	$1D(A2),D0		* $8 : @v2
		CMPI.B	#3,$1E(A2)
		BCC	_S88KBS_VOL22

		MOVEQ.L	#$00,D0			* el̂
		MOVE.B	$06(A2),D1		* @v  v ɕϊ
		NEG.B	D1
		ADDI.B	#127,D1
		MOVEQ.L	#15-1,D2
		LEA.L	FM_VOL_TBL(PC),A1
_S88KBS_VOL21:
		CMP.B	(A1)+,D1
		BLS	_S88KBS_VOL22
		ADDQ.B	#1,D0
		DBRA.W	D2,_S88KBS_VOL21
_S88KBS_VOL22:
		CMP.B	KBS_TL2(A0),D0
		BEQ	_S88KBS_DATA
		BSET.L	#8,D6
		MOVE.B	D0,KBS_TL2(A0)

_S88KBS_DATA:
		MOVEQ.L	#$00,D0			* $9 : DATA
		MOVE.W	$02(A2),D0
		ADD.L	SORC88_DATAADR(A6),D0
		CMP.L	KBS_DATA(a0),D0
		BEQ	_S88KBS_KC1
		BSET.L	#9,D6
		MOVE.L	D0,KBS_DATA(A0)

_S88KBS_KC1:
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D1
		MOVE.B	$07(A2),D0
		MOVE.B	D0,D1
*
		CMPI.B	#3,$1E(A2)		* rrf̏ꍇ
		BCC	_S88KBS_KC1S

* KEYCODE FM
		ANDI.B	#$70,D1
		LSL.W	#7,D1
		ANDI.B	#$0F,D0
		ADD.W	D0,D0
		LEA.L	FNUM_TBL(PC),A1
		MOVE.W	(A1,D0.W),D0
		OR.W	D1,D0
		MOVE.B	$08(A2),D1
		EXT.W	D1
		ADD.W	D1,D0
		BRA	_S88KBS_KC12

* KEYCODE SSG
_S88KBS_KC1S:
		LSR.B	#4,D1
		ANDI.B	#$0F,D0
		ADD.W	D0,D0
		LEA.L	FREQ_TBL(PC),A1
		MOVE.W	(A1,D0.W),D0
		MOVE.B	$08(A2),D2
		EXT.W	D2
		ADD.W	D2,D0
*
		TST.B	D1
		BEQ	_S88KBS_KC12
_S88KBS_KC1S2:
		LSR.W	#1,D0
		SUBQ.B	#1,D1
		BNE	_S88KBS_KC1S2
_S88KBS_KC12:
		CMP.W	KBS_KC1(A0),D0		* $A : KC1
		BEQ	_S88KBS_KC2
		BSET.L	#$A,D6
		MOVE.W	D0,KBS_KC1(A0)

_S88KBS_KC2:
		MOVE.W	$1A(A2),D0
		CMPI.B	#2,$1E(A2)		* el̓XLbv
		BLS	_S88KBS_KC22
*
		MOVE.B	$1C(A2),D1		* rrf̂
		BEQ	_S88KBS_KC22
_S88KBS_KC21:
		LSR.W	#1,D0
		SUBQ.B	#1,D1
		BNE	_S88KBS_KC21
_S88KBS_KC22:
		CMP.W	KBS_KC2(A0),D0		* $B : KC2
		BEQ	_S88KBS_P
		BSET.L	#$B,D6
		MOVE.W	D0,KBS_KC2(A0)

_S88KBS_P:
		CMPI.B	#3,$1E(A2)
		BCC	_S88KBS_PS
* FM
		BSR	GET_BEND
		BRA	_S88KBS_P2
* SSG
_S88KBS_PS:
		MOVE.W	KBS_KC2(A0),D0
		MOVE.W	KBS_KC1(A0),D1
		SUB.W	D1,D0
		NEG.W	D0
_S88KBS_P2:
		CMP.W	KBS_P(A0),D0
		BEQ	_S88KBS_LOOPE
		BSET.L	#3,D6
		MOVE.W	D0,KBS_P(A0)
		MOVE.W	D0,T_BEND(A3)		* P: ̒lxhW

_S88KBS_LOOPE:
		MOVE.W	D6,KBS_CHG(A0)		* ωtOZbg
		LEA.L	CHST(A0),A0		* next MMDSP CHANNEL BUFFER
		LEA.L	$20(A2),A2		* next SORCSR WORK ADDRESS
		LEA.L	TRST(A3),A3		* next MMDSP TRACK BUFFER
		DBRA.W	D7,_S88KBS_LOOP
		RTS

*
* SET KEYBOARD STATUS
*
SET_TRACK_STATUS:
		LEA.L	M_CH1(A5),A0
		LEA.L	TRACK_STATUS(A6),A3

		MOVEQ.L	#$00,D2			*gbNt󋵎o
		MOVEQ.L	#$00,D0
_S88_TRK2:
		TST.B	$1F(A0)			* b7=ON:TRACK END
		BMI	_S88_TRK22
		BTST.B	#6,$10(A0)		* b6=ON:MASK ON  OFF:MASK OFF
		BNE	_S88_TRK22
		BSET.L	D0,D2
_S88_TRK22:
		LEA.L	$20(A0),A0
		ADDQ.B	#1,D0
		CMPI.B	#6,D0
		BCS	_S88_TRK2

		MOVE.L	TRACK_ENABLE(A6),D0
		MOVE.L	D2,TRACK_ENABLE(A6)
		EOR.L	D2,D0
		MOVE.L	D0,TRACK_CHANGE(A6)
* FM 1-3
		LEA.L	M_CH1(A5),A1
		LEA.L	KEYONWK(A6),A2
		LEA.L	TRACK_STATUS(A6),A3
		MOVEQ.L	#$00,D7			* FM 1-3
SET_TRACK_STATUS2:
		BSR	GET_TRACK_FM
		LEA.L	$20(A1),A1
		ADDQ.L	#2,A2
		LEA.L	TRST(A3),A3
		ADDQ.W	#1,D7
		CMPI.W	#$03,D7
		BCS	SET_TRACK_STATUS2

* SSG 1-3
SET_TRACK_STATUS3:
		BSR	GET_TRACK_SSG
		LEA.L	$20(A1),A1
		ADDQ.L	#2,A2
		LEA.L	TRST(A3),A3
		ADDQ.W	#1,D7
		CMPI.W	#$06,D7
		BCS	SET_TRACK_STATUS3
		RTS


*elgbNXe[^Xo
*	a0.l <- SORCSR WORK AREA
*	a1.l <- CHANNEL WORK
*	a2.l <- keyon buffer address
*	a3.l <- TRACK_STATUS address

GET_TRACK_FM:
		MOVEQ.L	#$00,D5
		MOVE.L	D5,T_STCHANGE(A3)	* FLAG RESET

		MOVEQ.L	#$C0,D0			* FM PAN(DUMMY)
		ROL.B	#2,D0
		CMP.W	T_PAN(A3),D0
		BEQ	GET_TRACK_FM10
		BSET.L	#2,D5
		MOVE.W	D0,T_PAN(A3)

GET_TRACK_FM10:
		BSET.L	#1,D5			* FM BEND(DUMMY)

		MOVEQ.L	#$00,D0
		MOVE.B	$06(A1),D0		* $7 : @v1
		NEG.B	D0			* FM ̏ꍇ
		ADDI.B	#127,D0
		ANDI.B	#$7F,D0
		CMP.B	T_VELOCITY(A3),D0
		BEQ	GET_TRACK_FM51
		MOVE.B	#$01,T_VELCHANGE(A3)
		MOVE.B	D0,T_VELOCITY(A3)

GET_TRACK_FM51:
		MOVEQ.L	#$00,D0			* FM PROGRAM
		MOVE.B	$05(A1),D0
		CMP.W	T_PROGRAM(A3),D0
		BEQ	GET_TRACK_FM40
		MOVE.W	D0,T_PROGRAM(A3)
		BSET.L	#3,D5

GET_TRACK_FM40:
		BSR	FM_KEYONCHK
		BVS	GET_TRACK_FM60
		SCS.B	D0
		ORI.B	#$FE,D0
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		MOVE.B	D0,T_KEYONSTAT(A3)
GET_TRACK_FM60:
		MOVEQ.L	#$00,D0
		MOVE.B	$07(A1),D0		* NOTE.b 4hb OCTAVE
						*	 4lb NOTE
		MOVE.L	A0,-(SP)
		LEA.L	KEY_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_KEYCODE(A3),D0		* FM KEYBOARD
		BEQ	GET_TRACK_FM90
		MOVE.B	#$01,T_KEYCHANGE(A3)
		MOVE.B	D0,T_KEYCODE(A3)

GET_TRACK_FM90:
		MOVE.L	(SP)+,A0
		MOVE.B	D5,T_STCHANGE(A3)
		RTS


*rrfgbNXe[^Xo
*	a1.l <- CHANNEL WORK
*	a2.l <- keyon buffer address
*	a3.l <- TRACK_STATUS address

GET_TRACK_SSG:
		MOVEQ.L	#$00,D5			* FLAG RESET
		MOVE.L	D5,T_STCHANGE(A3)

		MOVEQ.L	#$C0,D0			* SSG PAN(DUMMY)
		ROL.B	#2,D0
		CMP.W	T_PAN(A3),D0
		BEQ	GET_TRACK_SSG00
		BSET.L	#2,D5
		MOVE.W	D0,T_PAN(A3)

GET_TRACK_SSG00:
		BSET.L	#1,D5			* SSG BEND(DUMMY)

GET_TRACK_SSG10:
		MOVE.B	$06(A1),D0		* @v1
*		MOVE.B	$1D(A1),D0		* @v2
		ANDI.W	#$000F,D0
		LEA.L	SSG_TL_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_VELOCITY(A3),D0
		BEQ	GET_TRACK_SSG20
		MOVE.B	#$01,T_VELCHANGE(A3)
		MOVE.B	D0,T_VELOCITY(A3)
GET_TRACK_SSG20:
		MOVEQ.L	#$00,D0			* SSG PROGRAM
		MOVE.B	$05(A1),D0
		LSR.B	#4,D0
		ADDI.B	#100,D0
		CMP.W	T_PROGRAM(A3),D0
		BEQ	GET_TRACK_SSG30
		MOVE.W	D0,T_PROGRAM(A3)
		BSET.L	#3,D5
GET_TRACK_SSG30:
		BTST.B	#6,$10(A1)		* b6=ON:MASK ON  OFF:MASK OFF
		BNE	GET_TRACK_SSG32

		BSR	SSG_KEYONCHK
		BVS	GET_TRACK_SSG50
		ST.B	D0
		SUBQ.B	#1,D0
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		MOVE.B	D0,T_KEYONSTAT(A3)
		BRA	GET_TRACK_SSG50
* IF SSG MASK
GET_TRACK_SSG32:
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		ST.B	T_KEYONSTAT(A3)

GET_TRACK_SSG50:
		MOVEQ.L	#$00,D0
		MOVE.B	$07(A1),D0
		LEA.L	KEY_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_KEYCODE(A3),D0		* SSG KEYCODE
		BEQ	GET_TRACK_SSG90
		MOVE.B	#$01,T_KEYCHANGE(A3)
		MOVE.B	D0,T_KEYCODE(A3)

GET_TRACK_SSG90:
		MOVE.B	D5,T_STCHANGE(A3)
		RTS

*
* FM KEYON CHECK
*
* OUT	CCR : VS = SKIP KEYON FLAG CHANGE
*	      CC = KEYON
*
FM_KEYONCHK:
		TST.B	$1F(A1)
		BMI	KEYON_CHK3
		BTST.B	#0,$10(A1)		* REST
		BEQ	KEYON_CHK3
		CMPI.B	#$7F,$06(A1)
		BEQ	KEYON_CHK3
* CC : KEYON
		MOVE.B	$07(A1),D0
		ANDI.W	#$00FF,D0
		BSET.L	#8,D0
		CMP.W	(A2),D0
		BEQ	KEYON_CHK4		* EQ:NOT REWRITE
KEYON_CHK2:
		MOVE.W	D0,(A2)			* COPY KEYON KC
		ANDI.B	#$FE,CCR
		RTS

*
* SSG KEYON CHECK
*
* OUT	CCR : VS = SKIP KEYON FLAG CHANGE
*	      CC = KEYON
*
SSG_KEYONCHK:
		TST.B	$1F(A1)
		BMI	KEYON_CHK3
		TST.B	$1D(A1)
		BEQ	KEYON_CHK3
* CC : KEYON
		MOVE.B	$07(A1),D0
		ANDI.W	#$00FF,D0
		BSET.L	#8,D0
		CMP.W	(A2),D0
		BEQ	KEYON_CHK4		* EQ:NOT REWRITE
		MOVE.W	D0,(A2)			* COPY KEYON KC
		ANDI.B	#$FE,CCR
		RTS
KEYON_CHK3:
		CLR.W	(A2)
		ORI.B	#$02,CCR		* VS : SKIP
		RTS
KEYON_CHK4:
		BTST.B	#0,$0A(A1)		* TIE ON
		BNE	KEYON_CHK5
		CMPI.B	#$01,(A1)		* STEP COUNT PȉȂ KEYON 
		BLS	KEYON_CHK2
KEYON_CHK5:
		ORI.B	#$02,CCR		* VS : SKIP
		RTS

*
* GET BEND RANGE
*
* IN	A0.L : mmdsp KEYBOARD WORK
* OUT	D0.W : BEND RANGE
*
GET_BEND:
		MOVEM.L	D2-D7,-(SP)
		MOVE.W	KBS_KC1(A0),D0
		MOVE.W	D0,-(SP)
		BSR	GET_BLOCK
		MOVE.W	D0,D4			* D4.W : KC1 BLOCK
		MOVE.W	(SP)+,D0
		MOVE.W	#%00000111_11111111,D1
		AND.W	D1,D0
		MOVE.W	D0,D5			* D5.W : KC1 F-Number
*
		MOVE.W	KBS_KC2(A0),D0
		MOVE.W	D0,-(SP)
		BSR	GET_BLOCK
		MOVE.W	D0,D6			* D6.W : KC2 BLOCK
		MOVE.W	(SP)+,D0
		MOVE.W	#%00000111_11111111,D1
		AND.W	D1,D0
		MOVE.W	D0,D7			* D7.W : KC2 F-Number

* CHECK BLOCK DIFF.
		MOVE.W	#$225,D0		* D0.W : $48F(B)-$26A(C)
		MOVEQ.L	#$00,D3			* D3.W : BLOCK DIFF
GET_BEND2:
		CMP.W	D4,D6
		BEQ	GET_BEND4
		BCS	GET_BEND3

* KC1 < KC2 : ADD 1 BLOCK
		ADD.W	D0,D3
		ADDQ.W	#1,D4
		BRA	GET_BEND2

* KC1 > KC2 : SUB 1 BLOCK
GET_BEND3:
		SUB.W	D0,D3
		SUBQ.W	#1,D4
		BRA	GET_BEND2

GET_BEND4:
		SUB.W	D5,D7			* (KC2 F-Num)-(KC1 F-Num)
		ADD.W	D7,D3
		MOVE.W	D3,D0
		MOVEM.L	(SP)+,D2-D7
		RTS

*
* GET BLOCK
*
* IN	D0.W : BLOCK + F-Number
* OUT	D0.W : BLOCK(0-7)
* BRK	D1
*
GET_BLOCK:
		ANDI.W	#%00111000_00000000,D0
		MOVEQ.L	#8+3,D1
		LSR.W	D1,D0
		RTS

*
* GET TRACK MASK
*
SORC88_GETMASK:
		MOVE.L	TRACK_ENABLE(A6),D0
		RTS

*
* GET SUPPORT FILE-EXT.
*
SORC88_FILEEXT:
		PEA.L	FILEEXT_DAT(PC)			* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

FILEEXT_DAT:
		.DC.B	_OPN,'OPN'
		.DC.B	_SN,'SN',0
		.DC.B	_MPF,'MPF'
		.DC.B	0
		.EVEN

*
* CHECK & EXEC FILE-EXT.
*
SORC88_FLOADP:
		MOVEM.L	D1/A1,-(SP)
		CMPI.B	#_OPN,D0
		BEQ	SORC88_OPN
		CMPI.B	#_SN,D0
		BEQ	SORC88_OPN
		CMPI.B	#_MPF,D0
		BEQ	mxdrv_mpf
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$FF,D0
		RTS

SORC88_OPN:
		MOVE.W	#0,-(SP)
		MOVE.L	A1,-(SP)
		DOS	_OPEN
		ADDQ.L	#6,SP
		MOVE.W	D0,D1
		BMI	SORC88_LOADERR
		SORCSR	_M_STOP

		MOVEA.L	SORC88_DATAADR(A6),A1
		PEA.L	$4000.W
		PEA.L	$D00(A1)
		MOVE.W	D1,-(SP)
		DOS	_READ
		DOS	_CLOSE
		LEA.L	10(SP),SP
		SORCSR	_M_PLAY_JUMP

		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$00,D0
		RTS

SORC88_LOADERR:
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$02,D0
		RTS

*
* PLAY
*
SORC88_PLAY:
		SORCSR	_M_PLAY_JUMP
		RTS

*
* PAUSE / STOP
*
SORC88_PAUSE:
SORC88_STOP:
		SORCSR	_M_STOP
		RTS

*
* FADEOUT
*
SORC88_FADEOUT:
		SORCSR	_M_FADEOUT
		RTS

*
* CONTINUE
*
SORC88_CONT:
		SORCSR	_M_PLAY
*		RTS

*
* NO SUPPORT FUNCTIONS
*
SORC88_SETMASK:
SORC88_SKIP:
SORC88_SLOW:
		RTS



		.END
